poj 3415 Common Substrings 后缀数组+单调栈
题意:求解两个字符串长度 大于等于k的所有相同子串对有多少个,子串可以相同,只要位置不同即可;两个字符串的长度不超过1e5;
如 s1 = "xx" 和 s2 = "xx",k = 1,这时s1[0] -> s2[0] 或s2[1],同理s1[1] 也可以对应两个,这时长度为1,当长度为2时,只能找出1个,所以总和为5;
思路:还是将两个字符串连接后求出height数组,只不过之后不能朴素地用O(n^2)枚举相同子串的长度在遍历height数组来得到答案了,这时需要用到单调栈优化(开了题解才知道的)
单调栈:维护一个height数组上升的栈,需要记录栈顶的height数值,同时在出栈时还要记录每个栈中元素所代表的个数,即到前一个栈中元素中,有多少个被当前元素出栈了。同时为了方便得到ans,还要维护一个tot,表示栈内所有元素对答案的贡献。即每一个height[i] >= k都能用height[i] - k + 1次,但是在出栈时,减掉的是栈顶元素比当前要入栈的元素多出的部分(这利用的是height数组的单调性),同时累计个数即可;
细节:由于计算的起点在左字符串和右字符串,我是分开来计算。对于另一边的同样是要入栈的,因为我们并没有改变height数组的值,入栈但是cnt = 0并不会对结果增加,但是却能保证栈顶元素的height值的正确性;
ps:ans最大值显然是会爆int的。直接为1e5个a;
#include<iostream> #include<cstdio> #include<cstring> #include<string.h> #include<algorithm> #include<vector> #include<cmath> #include<stdlib.h> #include<time.h> #include<stack> #include<set> #include<map> #include<queue> using namespace std; #define rep0(i,l,r) for(int i = (l);i < (r);i++) #define rep1(i,l,r) for(int i = (l);i <= (r);i++) #define rep_0(i,r,l) for(int i = (r);i > (l);i--) #define rep_1(i,r,l) for(int i = (r);i >= (l);i--) #define MS0(a) memset(a,0,sizeof(a)) #define MS1(a) memset(a,-1,sizeof(a)) #define MSi(a) memset(a,0x3f,sizeof(a)) #define inf 0x3f3f3f3f #define lson l, m, rt << 1 #define rson m+1, r, rt << 1|1 typedef long long ll; typedef pair<int,int> PII; #define N 200007 int sa[N],t[N],t2[N],c[N],wv[N]; int cmp(int *r, int a, int b, int l){ return r[a] == r[b] && r[a+l] == r[b+l]; } void build_sa(char *r, int n, int m){ // 倍增算法 r为待匹配数组 n为总长度 m为字符范围 int i, j, p, *x = t, *y = t2; for(i = 0; i < m; i++) c[i] = 0; for(i = 0; i < n; i++) c[x[i] = r[i]]++; for(i = 1; i < m; i++) c[i] += c[i-1]; for(i = n-1; i >= 0; i--) sa[--c[x[i]]] = i; for(j = 1, p = 1; p < n; j <<= 1, m = p){ for(p = 0, i = n-j; i < n; i++) y[p++] = i; for(i = 0; i < n; i++) if(sa[i] >= j) y[p++] = sa[i] - j; for(i = 0; i < n; i++) wv[i] = x[y[i]]; for(i = 0; i < m; i++) c[i] = 0; for(i = 0; i < n; i++) c[wv[i]]++; for(i = 1; i < m; i++) c[i] += c[i-1]; for(i = n-1; i >= 0; i--) sa[--c[wv[i]]] = y[i]; for(swap(x,y), p = 1, x[sa[0]] = 0, i = 1; i < n; i++){ x[sa[i]] = cmp(y, sa[i-1], sa[i], j) ? p - 1: p++; } } } int rk[N],height[N]; void getHeight(char *r,int n) { for(int i = 1;i <= n;i++) rk[sa[i]] = i; // rk[i]:后缀i在sa[]中的下标 for(int i = 0,j,k = 0; i < n; height[rk[i++]] = k){ for(k? k--:0 ,j = sa[rk[i] - 1];r[i+k] == r[j+k];k++); } } char s[N],str[N]; int stk[N],num[N]; ll solve(int n,int L,int k) { ll ans = 0,tot = 0,top = 0; for(int i = 2;i <= n;i++){ int cnt = 0; if(height[i] < k){ top = 0,tot = 0; continue; } if(sa[i-1] < L) cnt++,tot += height[i]-k+1; while(top && height[i] <= stk[top]){ tot -= num[top]*(stk[top]-height[i]);// 并没有+1; cnt += num[top--]; } stk[++top] = height[i];// 即使是另一边的还是要进栈;因为我们只是保留了栈内的总和tot,但是并没有修改height同时cnt = 0无影响; num[top] = cnt; if(sa[i] > L) ans += tot; } tot = 0,top = 0; for(int i = 2;i <= n;i++){ int cnt = 0; if(height[i] < k){ top = 0,tot = 0; continue; } if(sa[i-1] > L) cnt++,tot += height[i]-k+1; while(top && height[i] <= stk[top]){ tot -= num[top]*(stk[top]-height[i]); cnt += num[top--]; } stk[++top] = height[i]; num[top] = cnt; if(sa[i] < L) ans += tot; } return ans; } int main() { int k; while(scanf("%d",&k) == 1 && k){ scanf("%s%s",s,str); int n = strlen(s),L = n; s[n] = '#'+1,s[++n] = '\0'; strcat(s,str); n = strlen(s); s[n] = '#'; build_sa(s,n+1,'z'+1); getHeight(s,n); //for(int i = 2;i <= n;i++) cout<<height[i]<<" "<<sa[i]<<endl; // cout<<endl; printf("%I64d\n",solve(n,L,k)); } return 0; }